---
ogp_description_length: 148
---

# Welcome!

![](https://img.shields.io/badge/code%20style-ruff-black.svg?style=flat-square) ![](https://img.shields.io/badge/pyright-checked-black?style=flat-square)

![](https://img.shields.io/pypi/v/linkd.svg?style=flat-square) ![](https://img.shields.io/pypi/pyversions/linkd?style=flat-square) ![](https://img.shields.io/github/stars/tandemdude/linkd?style=flat-square) ![](https://img.shields.io/github/forks/tandemdude/linkd?style=flat-square)

![](https://img.shields.io/github/actions/workflow/status/tandemdude/linkd/ci.yml?branch=master&event=push&style=flat-square&logo=github) ![](https://img.shields.io/readthedocs/linkd?style=flat-square) ![](https://img.shields.io/badge/License-MIT-limegreen?style=flat-square) ![](https://img.shields.io/pypi/status/linkd?style=flat-square)

---

## Overview

Linkd is a powerful [dependency-injection](https://en.wikipedia.org/wiki/Dependency_injection) framework for
asyncio-based Python applications.

This library aims to provide an easy way for framework developers to provide dependency-injection functionality,
while also being suitable for use with standalone applications with a little bit more work.

For an example of `linkd` in action, have a look at [`hikari-lightbulb`](https://github.com/tandemdude/hikari-lightbulb) which
uses it to provide all dependency injection functionality.

---

:::{dropdown} Helpful Resources
:icon: question
- {doc}`Quickstart <quickstart>`
:::

:::{dropdown} Maintainers
:icon: git-branch
- [thomm.o (creator)](https://github.com/tandemdude)
:::

---

## Next Steps

::::{grid} 1 2 2 2
:gutter: 3

:::{grid-item-card} {material-outlined}`info;2em` Quickstart
:columns: 12
:link: quickstart
:link-type: doc

A simple guide to help you bootstrap your first application using linkd.
:::

:::{grid-item-card} {material-outlined}`code;2em` API Reference
:link: api-reference
:link-type: doc

Detailed reference documentation for linkd's public API, autogenerated from the code.
:::

:::{grid-item-card} {material-outlined}`timeline;2em` Changelog
:link: changelog
:link-type: doc

A history of the past versions of linkd and the changes introduced throughout.
:::
::::

:::{toctree}
:hidden:
:maxdepth: 2
quickstart
api-reference
changelog
:::

* {ref}`genindex`
